<?php

use think\migration\Migrator;

class CreateSysConfig extends Migrator
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('sys_config', ['engine' => 'InnoDB', 'comment' => '系统配置表']);
        $table->addColumn('group_id', 'integer', ['limit' => 11, 'null' => false, 'comment' => '分组ID'])
            ->addColumn('title', 'string', ['limit' => 64, 'null' => false, 'comment' => '配置标题'])
            ->addColumn('name', 'string', ['limit' => 64, 'null' => false, 'comment' => '配置名称'])
            ->addColumn('value', 'string', ['limit' => 4096, 'null' => true, 'default' => null, 'comment' => '配置值'])
            ->addColumn('extra', 'string', ['limit' => 4096, 'null' => true, 'default' => null, 'comment' => '配置额外信息'])
            ->addColumn('type', 'string', ['limit' => 64, 'null' => false, 'comment' => '配置类型: text, textarea, number, select, checkbox, radio, date, time, datetime'])
            ->addColumn('sort', 'integer', ['limit' => 11, 'null' => false, 'default' => 0, 'comment' => '排序'])
            ->addColumn('remark', 'string', ['limit' => 255, 'null' => true, 'default' => null, 'comment' => '备注'])
            ->addColumn('created_at', 'timestamp', ['null' => false, 'default' => 'CURRENT_TIMESTAMP', 'comment' => '创建时间'])
            ->addColumn('updated_at', 'timestamp', ['null' => false, 'default' => 'CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP', 'comment' => '更新时间'])
            ->addColumn('deleted_at', 'timestamp', ['null' => true, 'default' => null, 'comment' => '删除时间'])
            ->addIndex(['group_id', 'name'], ['unique' => true, 'name' => 'idx_unique_group_id_name'])
            ->create();
    }
}
